﻿import json
import datetime
import string
import psycopg2
import requests

def is_float(a_string):
	if a_string is None:
		return False
	try:
		float(a_string)
		return True
	except ValueError:
		return False


class Baz():
	"Stores name, serial and date"
	def __init__(self, name, serial, dt):
		self.name = name
		self.serial = serial
		self.dt = dt

def mindata(j: dict) -> dict:
	"""
	This function is finding min for new data 
	"""
	vec = []
	fin = []
	dictData = j
	for i in dictData:
		"relocating names and dates in vector, will be using as set"
		dictDatai = dictData[i]
		t = 0
		if dictDatai["uName"].find("Сервер") != -1:
			t = 1
		for s in vec:
			if s.name == dictDatai["uName"] and s.serial == dictDatai["serial"] and dictDatai["Date"][0:10] == s.dt:
				t = 1
		if t == 0:
			vec.append(Baz(dictDatai["uName"],dictDatai["serial"],str(dictDatai["Date"][0:10])))
	for k in vec:
		"creating vector of data for each pribor at each date"
		data = []
		for i in dictData:
			dictDatai = dictData[i]
			if dictDatai["uName"] == k.name and dictDatai["serial"] == k.serial and dictDatai["Date"][0:10] == k.dt:
				data.append(dictDatai["data"])
		"working with date"
		if len(data) != 0:
			for i in data:
				fl = False
				while fl == False:
					fl = True
					for h in i:
						if "system" == h[0:6] or h[0:3] == "RTC" or h[0:3] == "NTP" or h.find("calibr_date") != -1:
							i.pop(h)
							fl = False
							break
		if len(data) != 0:
			"comparison"
			for h in data[0]:
				if not is_float(data[0][h]):
					data[0][h] = None
				elif h.find("temp") != -1 and h.find("color_tempCT") == -1 and (float(data[0][h]) < -100 or float(data[0][h]) > 100):
					data[0][h] = None
				elif h.find("pressure") != -1 and (float(data[0][h]) < 100 or float(data[0][h]) > 1000):
					data[0][h] = None
				elif h.find("humidity") != -1 and (float(data[0][h]) < 0 or float(data[0][h]) > 100):
					data[0][h] = None
				for i in range(1,len(data)):
					if h in data[i]:
						tr = 0
						if not is_float(data[i][h]):
							tr = 1
						elif h.find("temp") != -1 and h.find("color_tempCT") == -1 and (float(data[i][h]) < -100 or float(data[i][h]) > 100):
							tr = 1
						elif h.find("pressure") != -1 and (float(data[i][h]) < 100 or float(data[i][h]) > 1000):
							tr = 1
						elif h.find("humidity") != -1 and (float(data[i][h]) < 0 or float(data[i][h]) > 100):
							tr = 1
						if tr == 0:
							if data[0][h] is None:
								data[0][h] = round(float(data[i][h]), 4)
							else:
								data[0][h] = round(float(min(float(data[0][h]), float(data[i][h]))), 4)
		"forming result"
		final = dict(Date= k.dt, uName = k.name, serial = k.serial, data = data[0])
		fin.append(final)
	fe = {}
	for i in range(len(fin)):
		fe.update({str(i): fin[i]})
	return fe

def maxdata(j: dict) -> dict:
	"""
	This function is finding max new data
	same system as min
	"""
	vec = []
	data = []
	fin = []
	t = 0
	dictData = j
	for i in dictData:
		dictDatai = dictData[i]
		t = 0
		for s in vec:
			if (s.name == dictDatai["uName"] and s.serial == dictDatai["serial"] and s.dt == dictDatai["Date"][0:10]) or dictDatai["uName"][0:6] == "Сервер":
				t = 1
		if t == 0:
			vec.append(Baz(dictDatai["uName"],dictDatai["serial"],str(dictDatai["Date"][0:10])))
	for k in vec:
		data = []
		for i in dictData:
			dictDatai = dictData[i]
			if dictDatai["uName"] == k.name and dictDatai["serial"] == k.serial and dictDatai["Date"][0:10] == k.dt:
				data.append(dictDatai["data"])
		if len(data) != 0:
			for i in data:
				fl = False
				while fl == False:
					fl = True
					for h in i:
						if "system" == h[0:6] or h[0:3] == "RTC" or h[0:3] == "NTP" or h.find("calibr_date") != -1:
							i.pop(h)
							fl = False
							break
		if len(data) != 0:
			for h in data[0]:
				if not is_float(data[0][h]):
					data[0][h] = None
				elif h.find("temp") != -1 and h.find("color_tempCT") == -1 and (float(data[0][h]) < -100 or float(data[0][h]) > 100):
					data[0][h] = None
				elif h.find("pressure") != -1 and (float(data[0][h]) < 100 or float(data[0][h]) > 1000):
					data[0][h] = None
				elif h.find("humidity") != -1 and (float(data[0][h]) < 0 or float(data[0][h]) > 100):
					data[0][h] = None
				for i in range(1,len(data)):
					if h in data[i]:
						tr = 0
						if not is_float(data[i][h]):
							tr = 1
						elif h.find("temp") != -1 and h.find("color_tempCT") == -1 and (float(data[i][h]) < -100 or float(data[i][h]) > 100):
							tr = 1
						elif h.find("pressure") != -1 and (float(data[i][h]) < 100 or float(data[i][h]) > 1000):
							tr = 1
						elif h.find("humidity") != -1 and (float(data[i][h]) < 0 or float(data[i][h]) > 100):
							tr = 1
						if tr == 0:
							if data[0][h] is None:
								data[0][h] = round(float(data[i][h]), 4)
							else:
								data[0][h] = round(float(max(float(data[0][h]), float(data[i][h]))), 4)
		final = dict(Date= k.dt, uName = k.name, serial = k.serial, data = data[0])
		fin.append(final)
	fe = {}
	for i in range(len(fin)):
		fe.update({str(i): fin[i]})
	return fe

def halfpath15(j: dict) -> dict:
	"""
	This function is finding sum and amount in 15 minutes
	"""
	vec = []
	data = []
	fin = []
	t = 0
	dictData = j
	for i in dictData:
		"appending our set of names and dates"
		dictDatai = dictData[i]
		t = 0
		for s in vec:
			if (s.name == dictDatai["uName"] and s.serial == dictDatai["serial"] and s.dt == dictDatai["Date"][0:10]) or dictDatai["uName"][0:6] == "Сервер":
				t = 1
		if t == 0:
			vec.append(Baz(dictDatai["uName"],dictDatai["serial"],str(dictDatai["Date"][0:10])))
	for k in vec:
		"working with data and deleting system info"
		tempk = k.name
		if (k.name[0:6] != "Сервер"):
			data = []
			for i in dictData:
				dictDatai = dictData[i]
				if dictDatai["uName"] == k.name and dictDatai["serial"] == k.serial and dictDatai["Date"][0:10] == k.dt:
					data.append(dictDatai["data"])
			if len(data) != 0:
				for i in data:
					fl = False
					while fl == False:
						fl = True
						for h in i:
							if "system" == h[0:6] or h[0:3] == "RTC" or h[0:3] == "NTP" or h.find("calibr_date") != -1:
								i.pop(h)
								fl = False
								break
			templendata = len(data)
			tempdata = {}
			if templendata != 0:
				"averaging"
				for h in data[0]:
					lena = 1
					if not is_float(data[0][h]):
						data[0][h] = "0"
						lena -= 1
					elif h.find("temp") != -1 and h.find("color_tempCT") == -1 and (float(data[0][h]) < -100 or float(data[0][h]) > 100):
						data[0][h] = "0"
						lena -= 1
					elif h.find("pressure") != -1 and (float(data[0][h]) < 100 or float(data[0][h]) > 1000):
						data[0][h] = "0"
						lena -= 1
					elif h.find("humidity") != -1 and (float(data[0][h]) < 0 or float(data[0][h]) > 100):
						data[0][h] = "0"
						lena -= 1
					sum = float(data[0][h])
					for i in range(1,templendata):
						if h in data[i]:
							tr = 0
							if not is_float(data[i][h]):
								tr = 1
							elif h.find("temp") != -1 and h.find("color_tempCT") == -1 and (float(data[i][h]) < -100 or float(data[i][h]) > 100):
								tr = 1
							elif h.find("pressure") != -1 and (float(data[i][h]) < 100 or float(data[i][h]) > 1000):
								tr = 1
							elif h.find("humidity") != -1 and (float(data[i][h]) < 0 or float(data[i][h]) > 100):
								tr = 1
							if tr == 0:
								lena += 1
								sum += float(data[i][h])
					data[0][h] = round(sum, 4)
					tempdata.update({str(h): lena})
			# print(data[0], data[1])
			final = dict(Date= k.dt, uName = k.name, serial = k.serial, summa = data[0], length = tempdata)
			# print(final)
			fin.append(final)
	fe = {}
	for i in range(len(fin)):
		fe.update({str(i): fin[i]})
	return fe

def aver15(j: dict) -> dict:
	"""
	This function is finding average in 15 minutes
	"""
	fin = []
	dictData = j
	for i in dictData:
		"appending our set of names and dates"
		dictDatai = dictData[i]
		data = dict()
		for t in dictDatai["summa"]:
			if int(dictDatai["length"][t]) == 0:
				data[t] = 0.0000
			else:
				data[t] = round(float(dictDatai["summa"][t])/int(dictDatai["length"][t]), 4)
		final = dict(Date= dictDatai["Date"], uName = dictDatai["uName"], serial = dictDatai["serial"], avr = data)
		fin.append(final)
	fe = {}
	for i in range(len(fin)):
		fe.update({str(i): fin[i]})
	return fe

def uploadolddata(y, m: string) -> json:
	"uploading old data from archive"
	with open('/home/alenanaz/db_all_' + y + '_' + m + '.json', encoding="utf8") as f:
		templates = json.load(f)
	return templates

def insert15min(p: dict, dbn, usavr, passavr, hostavr, tabavr, tabhp, datetime: string):
	"""
	inserting avr in data base
	"""
	p1 = aver15(p);
	"connecting to the data base"
	conn = psycopg2.connect(dbname=dbn, user=usavr,password=passavr, host=hostavr)
	cursor = conn.cursor()
	"sql queries"
	for i in p1:
		if (p1[i]["uName"][0:6] != "Сервер") and p1[i]["avr"] != {}:
			cursor.execute(f'INSERT INTO {tabavr} VALUES(%s, %s, %s, %s)', (datetime, (str(p1[i]["uName"]) + ' ' + str(p1[i]["serial"])), "average_of_day", json.dumps(p1[i]["avr"], ensure_ascii=False)))
	conn.commit()

def insertmin15(p: dict, dbn, usavr, passavr, hostavr, tabavr, datetime: string):
	"""
	inserting min in data base
	"""
	"connecting to the data base"
	conn = psycopg2.connect(dbname=dbn, user=usavr,password=passavr, host=hostavr)
	cursor = conn.cursor()
	"sql queries"
	for i in p:
		if (p[i]["uName"][0:6] != "Сервер") and p[i]["data"] != {}:
			cursor.execute(f'INSERT INTO {tabavr} VALUES(%s, %s, %s, %s)', (datetime, (str(p[i]["uName"])+' '+str(p[i]["serial"])), "minimum_in_day", json.dumps(p[i]["data"], ensure_ascii=False)))
	conn.commit()

def insertmax15(p: dict, dbn, usavr, passavr, hostavr, tabavr, datetime: string):
	"""
	insert max in db
	"""
	"connecting to db"
	conn = psycopg2.connect(dbname=dbn, user=usavr,password=passavr, host=hostavr)
	cursor = conn.cursor()
	"sql queries"
	for i in p:
		if (p[i]["uName"][0:6] != "Сервер") and p[i]["data"] != {}:
			cursor.execute(f'INSERT INTO {tabavr} VALUES(%s, %s, %s, %s)', (datetime, (str(p[i]["uName"])+' '+str(p[i]["serial"])), "maximum_in_day", json.dumps(p[i]["data"], ensure_ascii=False)))
	conn.commit()

if __name__ == "__main__":
    p = uploadolddata("2021", "09")
    olddate_time = '2021-09-01 00:00:00'
    old = datetime.datetime.strptime(olddate_time, '%Y-%m-%d %H:%M:%S')
    while (old < datetime.datetime.strptime('2021-10-01 00:00:00', '%Y-%m-%d %H:%M:%S')):
        now = old + datetime.timedelta(days=1)
        date_time = now.strftime("%Y-%m-%d %H:%M:%S")
        print(date_time, '   ', olddate_time)
        fe = {}
        tim = 0
        for i in p:
            "relocating names and dates in vector, will be using as set"
            dictDatai = i
            if (dictDatai["uName"].find("Сервер") == -1 and datetime.datetime.strptime(dictDatai["Date"], '%Y-%m-%d %H:%M:%S') < now and datetime.datetime.strptime(dictDatai["Date"], '%Y-%m-%d %H:%M:%S') >= old):
                fe.update({str(tim): i})
                tim += 1
        t = halfpath15(fe)
        insert15min(t, 'averobo', 'averobo', '*****', 'localhost', 'main_table', 'half_path', olddate_time[0:10])
        t = mindata(fe)
        insertmin15(t, 'averobo', 'averobo', '*****', 'localhost', 'main_table', olddate_time[0:10])
        t = maxdata(fe)
        insertmax15(t, 'averobo', 'averobo', '*****', 'localhost', 'main_table', olddate_time[0:10])
        old = now
        olddate_time = date_time
    print('t')
