﻿import json
import datetime
import requests
import psycopg2
import logging
from mypythonlib2 import function_15_min

if __name__ == "__main__":
    logging.basicConfig(level=logging.INFO, filename="db_log1.log", filemode="a", format="%(asctime)s %(levelname)s %(message)s")
    try:
        now = datetime.datetime.now()
        old = now - datetime.timedelta(minutes=15)
        date_time = now.strftime("%Y-%m-%d %H:%M:%S")
        funcdate = date_time
        olddate_time = old.strftime("%Y-%m-%d %H:%M:%S")
        date_time = date_time[0:10] + '%20' + date_time[11:19]
        olddate_time = olddate_time[0:10] + '%20' + olddate_time[11:19]
        req = requests.get('http://webrobo.mgul.ac.ru:3000/db_api_REST/calibr/log/' + olddate_time + '/' + date_time + '/')
        data = req.json()
        p = function_15_min.mindata(data)
        function_15_min.insertmin15(p,'averobo','averobo','*****','localhost', 'table_with_time', funcdate)
        p = function_15_min.maxdata(data)
        function_15_min.insertmax15(p,'averobo','averobo','*****','localhost', 'table_with_time', funcdate)
        p = function_15_min.halfpath15(data)
        function_15_min.insert15min(p,'averobo','averobo','*****','localhost', 'table_with_time', 'half_path', funcdate)
        logging.info("Everything is good in 15 minutes")
    except:
        logging.error("Something went wrong in 15 minutes:", exc_info=True)
